#line 1 "D:/Dokumenty/_PROJEKTY/metal_detector/MetalDetector/main.c"




unsigned int frequency;
unsigned int history[ 20 ];
unsigned char historyPos = 0;
unsigned long accum = 0;
long delta = 0;


void dbg_write_str(const char* str) {
 while (*str) {
 Soft_UART_Write(*str);
 str++;
 }
}

void ltoa(long i, char* str) {
 int pos = 7;
 str[8] = '\0';
 while (pos >= 0) {
 unsigned char hex = i & 0x0F;
 if (hex < 10) {
 str[pos] = '0' + hex;
 } else {
 str[pos] = 'A' + hex - 10;
 }
 i >>= 4;
 pos--;
 }
}

void dbg_write_long(long val) {
 char buf[9];
 char* ptr;
 ltoa(val, buf);
 ptr = buf;
 while (*ptr) {
 Soft_UART_Write(*ptr);
 ptr++;
 }
}

void beepH(void) {
 int i;
 for (i=0; i<20; i++) {
 PORTA.B4 = 1;
 Delay_ms(1);
 PORTA.B4 = 0;
 Delay_ms(1);
 }
}

void beepL(void) {
 int i;
 for (i=0; i<20; i++) {
 PORTA.B4 = 1;
 Delay_ms(2);
 PORTA.B4 = 0;
 Delay_ms(2);
 }
}

void measureFrequency(void) {
 TMR1H = 0x00;
 TMR1L = 0x00;
 T1CON = 0b00000111;
 Delay_ms( 700 );
 T1CON = 0b00000110;
 frequency = TMR1H;
 frequency = frequency << 8;
 frequency = frequency + TMR1L;
}

void main() {
 int i;





 OSCCON = 0x40;

 ANSEL = 0x00;

 ANSEL.B7 = 0;
#line 100 "D:/Dokumenty/_PROJEKTY/metal_detector/MetalDetector/main.c"
 CMCON0 = 0x06;

 ANSEL.B4 = 1;
 ANSEL.B5 = 1;

 TRISC.B4 = 0;

 TRISA.B4 = 0;

 beepH();
 beepL();
 beepH();
 beepL();

 measureFrequency();
 for (i=0; i< 20 ; i++) {
 history[i] = frequency;
 }

 do {
 measureFrequency();
#line 126 "D:/Dokumenty/_PROJEKTY/metal_detector/MetalDetector/main.c"
 accum = 0;
 for (i=0; i< 20 ; i++) {
 accum += history[i];
 }

 delta = (long)frequency *  20 ;

 if (delta > accum) {
 delta = delta - accum;
 delta *=  45000 ;
 if (delta > accum) {
 beepH();
 }
 } else {
 delta = accum - delta;
 delta *=  45000 ;
 if (delta > accum) {
 beepL();
 }
 }

 history[historyPos] = frequency;
 historyPos++;
 if (historyPos >=  20 ) {
 historyPos = 0;
 }

 } while(1);
}
